/*-----------------------------------------------------------------------------
 * 	Copyright (c) 2008 Mark Hummel DBA Raquette Software.
 *		All rights reserved
 *
 *    This file contains source code written by Raquette Software, 
 *    68 Stewart Street, Franklin MA 02038. It may not be used without 
 *    express written permission. The expression of the information 
 *    contained herein is protected under federal copyright laws and 
 *    all copying without permission is prohibited and may be subject 
 *    to criminal penalties. The Author assumes no responsibility for 
 *    errors, omissions, or damages caused by the use of these programs 
 *    or from use of the information contained herein.
 *
 *-----------------------------------------------------------------------------
 */
/******************************************************************************
 *
 *
 *	   stats.h
 *		- definition for statistic classes
 *
 ******************************************************************************
 */

#ifndef STATS_H
#define STATS_H

#include <list>
using namespace std;


/*************************************************************
 * Statistics infrastructure
 ************************************************************/
/*
 * virtual class for each statistics widget
 */
class Stats {
public:
    virtual const char* Name() = 0;
    virtual unsigned long long TotalCycles() = 0;
    virtual void Dump( unsigned long long totalTicks ) = 0;
};

class MasterStats {
list<Stats*> widgets;
unsigned long long int startTime;
public:
    MasterStats();
    ~MasterStats();
    void Add( Stats* widget );
    void Start();
    void Dump();
};
extern MasterStats masterStats;

#endif // STATS_H
